`timescale 1ns / 1ps

module Controller(Inst, neg, zero, reset, srcB, op,
                  regWrite, wrDataSel, wrRegSel, PCSel,
                  mr, mw, clk);

  input	[31:0] Inst;
  input	neg, zero, reset;
  output reg	[1:0] PCSel; 
  output reg	[5:0] op;
  output reg	srcB, regWrite, wrDataSel, wrRegSel;
  output reg	mr, mw;
  input	clk;

  parameter ALU		= 6'h00; // op =  0
  parameter LW		= 6'h23; // op = 35
  parameter SW		= 6'h2b; // op = 43
  parameter BEQ		= 6'h04; // op =  4 
  parameter ADDI	= 6'h08; // op =  8
  parameter J		= 6'h02; // op =  2
  parameter HALT	= 6'h3f; // op = 63

  parameter ADD 	= 6'h20; // funct = 32
  parameter SUB 	= 6'h22; // funct = 34
  parameter AND 	= 6'h24; // funct = 36
  parameter OR 		= 6'h25; // funct = 37
  parameter SLT 	= 6'h2a; // funct = 42
  
  // place your declarations here!
  
  wire [5:0] opcode;
  wire [5:0] aluOp;
  
  assign opcode = Inst[31:26];	// extract important fields from Inst
  assign aluOp = Inst[5:0];
  
  // place your controller logic here! 
  
  always @(opcode or reset or neg or zero) begin 
	  if(reset) begin
		// Assign Control Signals
	  end
	  else begin
	  	case(opcode)
		 // INST:  blah blah blah
		 // Default: foo
  		endcase
	 end
  end

endmodule
